function water(x, y, w, h)
	return	tobj {
			nam = 'water';
			obstacle = true;
			x = x;
			y = y;
			w = w;
			h = h;
			used = true;
		};
end

rope = tobj {
	nam = 'веревка';
	tile = 16;
	inv = "Прочная и длинная веревка -- таккелаж лодки.";
	nouse = "Зачем тут веревка?";
	use = function(s, w)
		if nameof(w) == 'kolodec' then
			return "За что привязать конец?"
		end
		if nameof(w) == 'tree1' then
			if w.y == 7 then
				p "Я привязал веревку одним концом к бревну, а другой сбросил в колодец."
			else
				return "Слишком далеко от колодца, нет смысла это делать."
			end
			remove(s, me())
		end
	end
}

brevno = function(s)
	local dx = s.x - me().x
	local dy = s.y - me().y
	local x = s.x + dx
	local y = s.y + dy
	local wall = isWall(x, y)
	if s._water then
		me().x = s.x
		me().y = s.y
		return true
	end
	if isWall(x, y) or x >= W or y >= H or x < 0 or y < 0 then
		return
	end
	local i,o, w, h
	for i,o in opairs(objs()) do
	w = 1; h = 1
	if o.w then w = o.w end
		if o.h then h = o.h end
		if isObject(o) and not isDisabled(o) then
			if x >= o.x and y >= o.y and x < o.x + w and y < o.y + h then
				if nameof(o) == 'water' then
					s._water = true
					s.obstacle = false
					break
				end
				if o.obstacle or o.brevno then
					return
				end
			end
		end
	end
	s.x = x
	s.y = y
	me().x = me().x + dx
	me().y = me().y + dy
	return true
end
game_start = troom {
	nam = 'У башни';
	dsc = [[И вот я на Черном полуострове. Это мрачное место. Зловещая башня возвышается над обрывом. 
		Крики чаек на фоне шума волн звучат как плач. Предзакатные лучи солнца отбрасывают длинные
		тени от узловатых ветвей деревьев.]];
	lifes = {[[Внезапно, с моря задул пронзительный ветер.]],
		[[Небо почернело, его заволокли тучи.]]};
	active = { [[Мне кажется, на верхнем этаже башни я вижу огонь. Арабелла, ты там?]],
		[[Как мне попасть внутрь башни?]]};
	dsc2 = [[Черная башня возвышается над обрывом.]];
	bg = {
		11,7,0,0,0,0,0,0,0,
		0,7,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,4,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
	};
	ground = {
		11,0,0,0,0,0,0,11,11,
		11,0,0,0,0,0,0,11,11,
		11,11,0,0,0,0,0,11,11,
		11,0,0,0,0,0,0,0,0,
		11,0,0,0,0,0,0,0,0,
		11,0,0,0,12,0,0,0,0,
		11,0,0,0,12,0,0,0,0,
		11,0,0,0,12,0,0,0,0,
		11,0,0,0,12,0,0,0,0,
	};
	wall = {
		0,0,3,1,1,1,2,0,0,
		0,0,3,1,1,1,2,0,0,
		0,0,3,1,1,1,2,0,0,
		0,0,3,1,1,1,2,0,0,
		0,0,3,1,0,1,2,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
	};
	obj = {
		tobj {
			nam = 'door';
			x = 4;
			y = 4;
			tile = 5;
			obstacle = true;
			act = "Надежная у колдуна дверь. Толстые металлические прутья и здоровый замок.";
			used = function(s, w)
				if w == topor then
					return "Боюсь, это повредит инструменту."
				end
			end
		},
		tobj {
			nam = 'kolodec';
			x = 8;
			y = 8;
			tile = 9;
			obstacle = true;
			used = function(s, w)
				if w == topor then
					p [[Топор улетел на дно колодца.]]
					remove(topor, me())
					put(topor, 'map2')
				end
			end;
			act = function(s)
				if taken 'rope' and not have 'rope' then
					p [[Я полез в высохший колодец.]]
					walk 'map2'
					return
				end
				p [[Высохший колодец. В нем нет воды. Да и цепи с ведром тоже.]];
			end
		},
		tobj {
			nam = 'tree1';
			var {
			x = 8;
			y = 6; };
			var { tile = 8; brevno =  false;  obstacle = true;};
			used = function(s, w)
				if w == topor then
					if s.brevno then
						return "Сейчас нет времени делать доски."
					end
					s.brevno = true
--					s.obstacle = false
					s.tile = 14
					pr "Готово!"
				end
			end;
			act = function(s)
				if s.brevno then
					return brevno(s)
				end
				return "Сухое дерево. Ни листика."
			end
		},
		tobj {
			nam = 'tree2';
			
			var { x = 6;
			y = 5; };
			var { tile = 8; brevno =  false; obstacle = true;};
			used = function(s, w)
				if w == topor then
					if s.brevno then
						return "Сейчас нет времени делать доски."
					end
					s.brevno = true
--					s.obstacle = false
					s.tile = 14
					p "Готово!"
				end
			end;
			act = function(s)
				if s.brevno then
					return brevno(s)
				end
				return "Сухое дерево. Ни листика."
			end
		},
		tobj {
			nam = 'boat';
			x = 0;
			y = 0;
			obstacle = true;
			tile = 15;
			used = function(s, w)
				if w == topor then
					p "Получи, проклятая лодка!"
					s:disable()
				end
			end;
			act = function(s)
				if not taken(rope) then
					p "На дне лодки лежала веревка. Я взял ее."
					take (rope)
				else
					p "Дырявая лодка. Откуда она здесь?"
				end
			end;
		},
		tobj {
			nam = 'win2';
			x = 3;
			y = 2;
			tile = 6;
		},
		tobj {
			nam = 'win1';
			x = 5;
			y = 0;
			tile = 6;
		},
		water(1, 2);
		water(0, 0, 1, 9);
		water(7, 0, 2, 3);
	};
}
