heart = tobj {
	nam = 'сердце';
	tile = 53;
	inv = 'Сердце проклятого Дактро!';
	obstacle = true;
	var { time = 16 };
	nouse = "К чему здесь сердце колдуна?";
	life = function(s)
		s.time = s.time - 1
		if s.time == 0 then
			lifeoff(s)
			if have 'arabella' and here() ~= map10 and here() ~= map12 then
				walkin 'happyend'
				return
			end
			gameover.tile = 53;
			if here() == map10 or here() == map12 then
				p [[Вдруг, послышался страшный грохот и стены башни, рассыпавшись, рухнули. Меня завалило камнями. Прости, Арабелла, я не смог спасти тебя!]]
			else
				p [[Земля под ногами сотрясалась с все нарастающей силой. Я посмотрел на башню и увидел, как она рушится! Обломки стен рассыпались у меня на глазах.
					Что я наделал! Ведь там осталась моя Арабелла! Прости меня, я не успел!]]
			end

			walkin 'gameover'
		else
			if here() == map10 or here() == map12 then
				p [[Я чувствую, как под ногами дрожит пол...]]
			else
				p [[Я чувствую, как трясется земля под ногами...]]
			end
		end
	end;
	used = function(s, w)
		if w == knife then
			p "Едва я пронзил сердце ножом,"
		elseif nameof(w) == 'fireplace' or nameof(w) == 'fire' then
			p "Едва я бросил сердце в огонь,"
		elseif w == topor then
			p "Едва я разрубил сердуе топором,"
		elseif w == fakel then
			p "Поджарить?"
			return
		else
			return
		end
		map10.noactive = true
		remove(s, me())
		put(blood, map12)
		blood.x = daktro.x
		blood.y = daktro.y
		daktro:disable()
		replace(rat, cat, me())
		if here() == map10 or here() == map12 then
			p "как пол башни задрожал."
		else
			p "как над башней засверкали всполохи молний и гул грома разнесся над островом."
		end
		if here() == map12 then
			p [[Черная фигура колдуна скорчилась и упала на пол.]];
		end
		lifeon(s);
	end;
	use = function(s, w)
		if nameof(w) == 'fireplace' or nameof(w) == 'fire' then
			return stead.call(s, 'used', w)
		end
		if w == rat then
			return [[-- Убери от меня эту гадость! Я боюсь крови!]]
		end
		if w == skeleton then
			if live(w) then
				p [[Увидев сердце, скелет остановился.]]
				lifeoff(w)
			end
		end
	end;
	act = function(s)
		p [[Не без содрогания я взял бьющееся сердце в руки.]]
		take(s)
	end
}

hbox = box(5, 3, 'heart');

map11nw = troom {
	nam = 'Остров';
	s = 'map11w';
	e = 'map11ne';
	refer = 'map11w';

	bg = {
		0,0,0,0,0,0,0,0,0,
		0,0,7,7,7,0,0,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
	};
	ground = {
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,12,0,0,0,0,
		0,0,0,0,12,0,0,0,0,
		0,0,0,0,12,0,0,0,0,
		0,0,0,0,12,0,0,0,0,
		0,0,0,0,12,0,0,0,0,
		0,0,0,0,12,0,0,0,0,
	};
	wall = {
		11,11,11,11,11,11,11,11,11,
		11,11,0,0,0,11,11,0,0,
		11,0,0,0,0,0,11,0,0,
		11,0,0,0,0,0,11,0,0,
		11,0,0,0,0,0,11,0,0,
		11,0,0,0,0,0,11,0,0,
		11,0,0,0,0,0,11,11,0,
		11,0,0,0,0,0,0,11,0,
		11,0,0,0,0,0,0,0,0,
	};
	obj = {
		tree(4, 2);
		stone(5, 4);
		tobj {
			nam = 'well';
			x = 2;
			y = 7;
			obstacle = true;
			act = [[Такой же сухой, как и деревья...]];
			tile = 9;
		},
		tobj {
			nam = 'hole';
			x = 5;
			y = 3;
			var { tile = false };
			used = function(s, w)
				if w == shovel and heart_know then
					if not s.tile then
						p [[Я принялся копать... Через несколько минут лопата со звоном ударилась о крышку ящика.]]
						putf(hbox)
						s.tile = 4
					else
						p [[Уже накопался.]]
					end
				end
				return true
			end
		};
		tree(2, 4);
		tree(7, 2);
		tree(6, 7);
		'edges', 'edgen', 'edgee', 'edgew',
	};
}
