map11w = troom {
	nam = 'Остров';
	refer = 'map11w';
	entered = function(s)
		if not have 'arabella' then
			set_music 'mus/1.ogg'
		end
	end;
	e = 'map11e';
	n = 'map11nw';
	s = 'map11sw';
	var { visited = false; };
	dsc = function(s)
		if not s.visited then
			s.visited = true
			p [[Я выбежал из портала. Под ногами была сухая трава. Над головой -- затянутое черными облаками небо. 
			От неожиданности у меня закружилась голова.^
			Я огляделся. Мы с крысой оказались на небольшом острове.^
			Черная башня была видна и отсюда, зловещий красный огонек горел словно маяк.^
			Что мы делаем в этом месте, когда Арабелла там, в черной башне?]]
		else
			if stead.here() == map11w then
				p [[Мы находимся на небольшом острове. Здесь расположен портал ведущий из башни.]]
			elseif stead.here() == map11nw then
				p [[Мы находимся на небольшом острове. Здесь есть ручей, стекающий к морю.]];
			elseif stead.here() == map11sw then
				p [[Мы находимся на небольшом острове. На берегу свалены большие камни.]]
			elseif stead.here() == map11e then
				p [[Мы находимся на небольшом острове. Черная башня хорошо видна отсюда. Небольшой ручей стекает к морю.]];
			elseif stead.here() == map11ne then
				p [[Мы находимся на небольшом острове. Унылый пейзаж наводит тоску.]];
			elseif stead.here() == map11se then
				p [[Мы находимся на небольшом острове. Здесь расположен еще один портал.]];
			end
		end
	end;
	active = { [[-- Не хочется здесь говорить, правда?^-- Да, остров хранит свою тайну.]]};
	lifes = { [[Волны с шумом набегают на берег.]], [[Я слышу крики чаек.]], [[Я слышу грохот грома.]], [[Желтая луна показалась из-за черных облаков.]],
		[[Мне кажется, я вижу, как дрожит красный огонек на вершине башни.]] },
	bg = {
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
		0,7,7,7,7,7,7,7,7,
	};
	ground = {
		0,0,0,0,12,0,0,0,0,
		0,0,0,0,12,0,0,0,0,
		0,0,0,0,12,0,0,0,0,
		0,0,0,0,12,0,0,0,0,
		0,0,0,0,12,0,0,0,0,
		0,0,0,0,12,0,0,0,0,
		0,0,0,0,12,0,0,0,0,
		0,0,0,0,12,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
	};
	wall = {
		11,0,0,0,0,0,0,0,0,
		11,11,0,0,0,0,0,0,0,
		11,11,0,0,0,34,33,0,0,
		11,11,0,0,0,0,31,0,0,
		11,11,0,0,0,0,0,0,0,
		11,11,0,0,0,0,0,0,0,
		11,11,0,0,0,0,0,0,0,
		11,0,0,0,0,0,0,0,0,
		11,0,0,0,0,0,0,0,0,
	};
	obj = {
		stone(4, 7);
		tobj {
			nam = 'pass';
			x = 7;
			y = 2;
			tile = 30;
		},
		tobj {
			nam = 'boat';
			x = 1;
			y = 6;
			used = function(s, w)
				if w == topor or w == fakel then
					p [[Эта лодка может пригодиться.]]
				end
			end;
			act = function(s)
				if visited 'happyend' then
					if have 'arabella' then
						return [[Арабелла без чувств!]]
					end
					walkin 'happyend2'
				else
					p [[Эта лодка может пригодиться нам с Арабеллой.]];
				end
			end;
			tile = 15;
		},
		tree(6, 5);
		tree(7, 7);
		tree(2, 2);
		'edges', 'edgen', 'edgee', 'edgew',
	};
}
