cat = tobj {
	nam = 'cat';
--	obstacle = true;
	tile = 57;
	var {x = 0, y = 0};
	inv = function(s)
		walkin(catdlg)
	end;
	used = function(s, w)
		if w == knife or w == topor or w == fakel then
			return [[Зачем терзать несчастную тварь?]]
		end
	end;
	life = function(s)
		local x, y
		if not here().troom_type then
			return
		end
		if player_moved() then
			if not seen(s) then
				put(s)
			end
			s.x, s.y = near(me(), here())
		end
		x, y = seek(s.x, s.y, me().x, me().y)
		if x == arabella.x and y == arabella.y then
			return
		end
		if x == me().x and y == me().y then
			return
		end
		s.x, s.y = x, y
	end;
}


catdlg = dlg {
	nam = 'Кот';
	hideinv = true;
	nolife = true;
	left = function(s, t)
		drop(cat, t)
		s.x, s.y = near(me(), t)
		lifeon(cat)
	end;
	entered = function(s)
	end;
	tile = 57;
	phr = {
		{ tag = 'cat1', [[Так вот кем ты был!]],
		[[Я не был, я всегда оставался котом, даже в этом постыдном обличии!!]], 
		[[pon 'cat2']] },
		{ tag = 'cat2', false,  [[Ты все еще умеешь разговаривать?]],
		[[-- Если уж научился разговаривать, то забыть это уже невозможно.]] },
		{ tag = 'cat', [[И что теперь?]], 
		    function(s)
				if visited(happyend) then
					p [[-- Домой, надо найти путь домой.]];
				else
					p [[-- Нужно спешить! Уничтожив сердце колдуна, ты уничтожил самого колдуна, а уничтожив колдуна, ты уничтожил его магию.
			Так что у нас мало времени, Черная башня вот-вот рухнет!]];
				end
		    end;
		},
		{},
	}
}

daktro = tobj {
	nam = 'daktro';
	var { x = 3;
	y = 5;};
	float = true;
	obstacle = true;
	tile = 54;
	life = function(s)
		if not here().troom_type then
			return
		end
		s.x, s.y = seek(s.x, s.y, me().x, me().y)
		if s.x == me().x and s.y == me().y then
			p "Дактро оказался совсем рядом. Его костлявые бледные руки потянулись к моему лицу... -- Сердце... -- услышал я шелест его голоса."
			gameover.tile = 54;
			walkin 'gameover'
		end
	end;
}
near = function(s, w)
	local x = s.x
	local y = s.y
	if x ~= 8 and not isSomething(x + 1, y, w) then
		x = x + 1
	elseif x ~= 0 and not isSomething(x - 1, y, w) then
		x = x - 1
	elseif y ~= 8 and not isSomething(x, y + 1, w) then
		y = y + 1
	elseif y ~= 0 and not isSomething(x, y - 1, w) then
		y = y - 1
	end
	return x, y
end
arabelladlg = dlg {
	nam = 'Арабелла';
	hideinv = true;
	nolife = true;
	entered = function(s)
	end;
	tile = 55;
	left = function(s, t)
		pon('b')
		if have(arabella) then
			drop (arabella, t)
			lifeon(arabella)
			arabella.x, arabella.y = near(me(), t)
		end
	end;
	phr = {
		{ tag = 'a', [[Арабелла, Арабелла! Ты жива? Все кончено!]],
		[[-- Ах, где я? -- Арабелла открыла глаза. Она жива!]], [[pon 'b']] },
		{ tag = 'b', false, [[Все будет хорошо!]], 
			[[-- Я знала, что ты придешь за мной, мой герой!]]};
		{},
	}
}

arabella = tobj {
	nam = 'arabella';
--	obstacle = true;
	var {
		x = 4;
		y = 3;
	};
	tile = 55;
	inv = function(s)
		if visited(happyend) then
			walkin 'arabelladlg'
		else
			p [[Арабелла без чувств.]];
		end
	end;
	life = function(s)
		local x, y
		if not here().troom_type then
			return
		end
		if player_moved() then
			if not seen(s) then
				put(s)
			end
			s.x, s.y = near(me(), here())
		end
		x, y = seek(s.x, s.y, me().x, me().y)
		if x == me().x and y == me().y then
			return
		end
		if x == cat.x and y == cat.y then
			return
		end
		s.x, s.y = x, y
	end;
	used = function(s, w)
		if w == knife or w == topor or w == fakel then
			p [[Эта игра не для садистов.]]
		end
		if w == cat or w == rat then
			p [[-- Я не ручной!]]
		end
	end;
	act = function(s)
		if visited(happyend) then
			return [[Моя Арабелла!]]
		end
		local t = exist 'tree'
		if not t.knife then
			return "Арабелла привязана к столбу!"
		end
		take(s)
		return "Я взвалил Арабеллу на плечо."
	end
}

fire = function(x, y)
	return tobj {
		nam = 'fire';
		x = x;
		y = y;
		tile = 47;
		obstacle = true;
		act = [[Сильное пламя!]];
	}
end

map12 = troom {
	nam = '9-й этаж';
	nodsc = true;
	dsc = function(s)
		p [[И вот, мы на самой вершине Черной башни!]]
		if disabled(daktro) then
			p [[Тело черного колдуна валяется на полу. Ему не нужно было сердце, но когда он лишился его, то лишился и жизни.]]
		else
			p [[Черный колдун Дактро приближается к нам!]]
		end
		p [[Повсюду горит дьявольский огонь.]]
		if not taken(arabella) then
			p [[Арабелла привязана к столбу! Проклятый колдун, надеюсь, что она жива!]]
		end
	end;
	entered = function(s)
		me().x = 7
		me().y = 7
		lifeon(daktro)
	end;
	left = function(s)
		lifeoff(daktro)
	end;
	bg = {
		0,0,0,0,0,0,0,0,0,
		0,18,18,18,18,18,18,18,0,
		0,18,46,46,46,46,46,18,0,
		0,18,46,46,46,46,46,18,0,
		0,18,46,46,18,46,46,18,0,
		0,18,46,46,46,46,46,18,0,
		0,18,46,46,46,46,46,18,0,
		0,18,18,18,18,18,18,18,0,
		0,0,0,0,0,0,0,0,0,
	};
	ground = {
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,48,0,0,0,48,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,48,0,0,0,48,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
	};
	wall = {
		1,1,1,1,1,1,1,1,1,
		2,0,0,0,0,0,0,0,3,
		2,0,0,0,0,0,0,0,3,
		2,0,0,0,0,0,0,0,3,
		2,0,0,0,0,0,0,0,3,
		2,0,0,0,0,0,0,0,3,
		2,0,0,0,0,0,0,0,3,
		2,0,0,0,0,0,0,0,3,
		1,1,1,1,1,1,1,1,1,
	};
	obj = {
		daktro,
		tobj {
			nam = 'out';
			x = 7;
			y = 7;
			tile = 17;
			act = function(s)
				if not have(arabella) then
					return
				end
				if have 'heart' and not disabled(daktro) then
					p [[Я ринулся по ступенькам вниз, но услышав за собой шум понял, что сделал ошибку...
					Проклятый колдун погубил]];
					if have 'arabella' then
						p [[нас.]]
					else
						p [[меня.]]
					end
					gameover.tile = 47;
					walkin 'gameover'
					return
				end
				walk 'map10'
			end
		},
		win(8, 7);
		win(8, 3);
		win(8, 1);
		win(7, 0);
		win(5, 0);
		win(3, 0);
		win(1, 0);
		win(0, 1);
		win(0, 3);
		win(0, 5);
		win(0, 7);
		win(1, 8);
		win(3, 8);
		win(5, 8);
		win(7, 8);
		fire(6, 6);
		fire(2, 6);
		fire(2, 2);
		fire(6, 2);

		tobj {
			nam = 'tree';
			obstacle = true;
			x = 4;
			y = 3;
			var { knife = false };
			tile = 56;
			used = function(s, w)
				if w == topor then
					if not s.knife then
						p [[Я могу задеть Арабеллу!]]
					else
						s:disable()
						p [[Проклятый столб!]]
						return
					end
					return
				end
				if w == knife then
					if not s.knife then
						s.knife = true
						return "Я разрезал путы."
					else
						return "Я уже разрезал веревки."
					end
				end
			end
		},
		arabella,
		tobj {
			nam = 'drova';
			x = 4;
			y = 4;
			tile = 48;
			used = function(s, w)
				if w == fakel then
					p [[Это плохая идея.]]
				end
			end
		},
	};
}

happyend = room {
	nam = 'Конец';
	hideinv = true;
--	scaledpic = 'gfx/end.png';
	pic = 'gfx/end4x.png';
	nolife = true;
	entered = function(s)
		set_music 'mus/6.ogg'
	end;
	dsc = [[Земля под ногами сотрясалась с все нарастающей силой. Я посмотрел на башню и увидел, как она рушится! Обломки стен рассыпались у меня на глазах.
		Мы успели! Арабелла все еще не подавала никаких признаков жизни, но я чувствовал, я знал, что все позади^
		Мы обязательно вернемся домой, и все будет хорошо.^
		Черные тучи над головой начинали постепенно рассеиваться и я впервые за эту ночь увидел звезды.^
		Их было множество! Они неторопливо и дружелюбно мерцали в ночной прохладе, радуясь вместе с нами.^^
		{b|Дальше}]];
	obj = { xact("b", code [[ walkout() ]]) };
}

--happyend2 = room {
--	nam = 'Конец';
--	hideinv = true;
--	nolife = true;
--	dsc = [[Happy end 2]];
--}
