
openable_door = function(x, y)
	return tobj {
			nam = 'door';
			var { opened = false };
			x = x;
			y = y;
			var { tile = 5; };
			var { obstacle = true; };
			act = function(s)
				if s.opened and s.obstacle then
					s.tile = 29;
					s.obstacle = false
					return 'Я открыл дверь.';
				end
				if not s.opened then
					p 'Дверь закрыта на замок. Нужен ключ.';
				end
			end;
			used = function(s, w)
				if w == key then
					p [[Ключ подошел!]]
					remove(w, me())
					s.opened = true
				end
			end;
		}
end

map5 = troom {
	nam = '3-й этаж';
	dsc = [[-- Все, больше никаких плит! Ты понял, Дактро? Мы обманули твои плиты! Гм... Снова скелет.
		Ну ничего, Дактро, мы уже знаем как обращаться с твоими верными, но безмозглыми охранниками...^
		Я сам не заметил, как начал разговаривать вслух.]];
	dsc2 = [[Геометрия комнаты полностью симметрична. Путь наверх расположен в центре этого этажа.]];
	lifes = {[[Гм, как же попасть на следующий этаж!!!]]};
	active = { [[Гм, видно у колдуна паранойя, иначе зачем ему все эти загадки и ловушки?]],
		[[-- Слушай, Крыса, может быть лучше называть тебя Крыс?^
		-- Отстань, а?^
		-- У тебя нет имени?^
		-- Мое имя умерло с моим прошлым...^
		-- Ничего, мы расквитаемся с мерзким колдуном!]]};
	entered = function(s)
		me().x = 4
		me().y = 8
		skeleton.fooled = false
		skeleton.started = false
		skeleton.x = 4
		skeleton.y = 0
		lifeon(skeleton)
		set_music 'mus/4.ogg'
	end;
	left = function(s)
		lifeoff(skeleton)
	end;
	bg = {
		0,0,0,0,18,0,0,0,0,
		0,18,18,18,18,18,18,18,0,
		0,18,18,18,18,18,18,18,0,
		0,18,18,18,18,18,18,18,0,
		0,18,18,18,4,18,18,18,0,
		0,18,18,18,18,18,18,18,0,
		0,18,18,18,18,18,18,18,0,
		0,18,18,18,18,18,18,18,0,
		0,0,0,0,18,0,0,0,0,
	};
	wall = {
		1,1,1,2,0,3,1,1,1,
		2,0,0,0,0,0,0,0,3,
		2,0,0,0,0,0,0,0,3,
		2,0,0,32,0,32,0,0,3,
		2,0,0,31,0,31,0,0,3,
		2,0,0,3,1,2,0,0,3,
		2,0,0,0,0,0,0,0,3,
		2,0,0,0,0,0,0,0,3,
		1,1,1,2,0,3,1,1,1,
	};
	obj = {
		tobj {
			nam = 'out';
			x = 4;
			y = 4;
			tile = 17;
			act = code [[ walk 'map6' ]];
		},
		openable_door(4, 3);
		win(0, 2),
		win(0, 6),
		win(8, 2),
		win(8, 6),
		box(5, 1, 'key'),
		box(6, 1),
		box(7, 1),
		box(6, 2),
		box(7, 2),
		box(7, 3),
		skeleton,
	};
}
