stopplz = dlg {
	nam = 'Крыса';
	nolife = true;
	hideinv = true;
	entered = function(s)
		p '-- Подожди! Ты же не оставишь меня здесь!!! -- окликнула меня крыса.';
	end;
	left = function(s)
		take(rat, map6);
	end;
	tile = 19;
	phr = {
		{always = true, 'Конечно нет.',  '-- Я верил, я знал!!!',  ' walkout()' };
		{always = true, 'Тебе придется остаться здесь!', '-- Нет, я не останусь один!', 'walkout()' };
		{},
	}
}

teleport = function(s)
	if me().x > s.x and me().y == 4 then
		me().x = 8
	elseif me().x < s.x and me().y == 4 then
		me().x = 0
	elseif me().y > s.y and me().x == 4 then
		me().y = 8
	elseif me().y < s.y and me().x == 4 then
		me().y = 0
	end
end

map6 = troom {
	nam = '4-й этаж';
	dsc = [[Мне сразу не понравилась геометрия этой комнаты. Почти симметричная, со множеством углов и какими-то проходами 
		во всех концах. Но назад пути нет, нам нужно наверх!!! В одном из углов я заметил странную плиту на полу.]];
	dsc2 = [[Эта комната надоедает мне все больше и больше. Скорей бы уже выбраться.]];
	lifes = { [[-- Смотри, вон в том углу...^
		-- Где?^
		-- Показалось...]],
		[[-- Крыса, а все же, кем ты был?^
		-- Сейчас это уже не важно...]],
		[[-- Слушай, эти телепортаторы, в них есть какой-то смысл?^
		-- Не уверен, Крыса, нужно ли искать логику в безумии?^
		-- А как иначе мы выберемся отсюда?]]};
	active = { 
		[[-- Ну давай уже уйдем отсюда...^
		 -- Я думаю, Крыса...^
		 -- Что тут думать, надо просто открыть эту дверь!^]],
		[[-- Мне здесь не нравится.^
		-- Мне тоже.^
		-- Ты скоро что-нибудь придумаешь?^
		-- Не мешай, если не знаешь как помочь.]],
		[[-- Ну скоро ты уже что-нибудь сделаешь?^
		-- Не мешай, Крыса, я думаю...^
		-- Что-то не очень это заметно.^
		-- У тебя есть идеи?^
		-- ...]]};
	entered = function(s)
		me().x = 4
		me().y = 4
		lifeon(s)
	end;
	left = function(s)
		lifeoff(s);
	end;
	life = function(s)
		local d = seen 'door'
		if here() ~= s then
			return
		end
		if isObstacle(6, 7) then
			d.obstacle = false
			d.tile = 29
			return
		end
		if me().x == 6 and me().y == 7 then
			d.tile = 29
		else
			d.tile = 5
			d.obstacle = true
		end
	end;
	bg = {
		4,4,4,4,4,4,4,4,4,
		4,0,0,0,18,0,4,0,4,
		4,18,18,18,18,18,18,0,4,
		4,18,18,18,18,18,18,0,4,
		4,18,18,18,18,18,18,18,4,
		4,0,18,18,18,18,18,0,4,
		4,0,18,18,18,18,18,0,4,
		4,0,0,0,18,0,18,0,4,
		4,4,4,4,4,4,4,4,4,
	};
	ground = {
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,17,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
	};
	wall = {
		0,0,0,2,0,3,0,0,0,
		0,1,1,2,0,3,0,3,0,
		0,2,0,0,0,0,0,3,0,
		0,0,0,0,0,0,0,3,1,
		0,0,0,0,0,0,0,0,0,
		1,2,0,0,0,0,0,3,1,
		0,2,0,0,0,0,0,3,0,
		0,1,1,2,0,3,0,1,0,
		0,0,0,2,0,3,0,0,0,
	};
	obj = {
		tobj {
			nam = '';
			x = 0;
			y = 4;
			tile = 30;
			act = teleport;
			obstacle = true;
		},
		tobj {
			nam = '';
			x = 8;
			y = 4;
			tile = 30;
			act = teleport;
			obstacle = true;
		},
		tobj {
			nam = '';
			x = 4;
			y = 8;
			tile = 30;
			act = teleport;
			obstacle = true;
		},
		tobj {
			nam = '';
			x = 4;
			y = 0;
			tile = 30;
			act = teleport;
			obstacle = true;
		},
		tobj {
			nam = 'pad';
			x = 6;
			y = 7;
			tile = 27;
			used = function(s, w)
				if w == rat and not isObstacle(s.x, s.y) then
					drop(rat)
					rat.x = s.x
					rat.y = s.y
					return "-- Посиди пока тут."
				end
			end;
		},
		tobj {
			nam = 'door';
			x = 6;
			y = 1;
			act = function(s)
				if s.obstacle then
					return [[Железная дверь. Закрыта и замка не видно.]];
				end
			end;
			var { tile = 5;
			obstacle = true; };
		},
		block(1, 3, 2);
--		block(1, 2, 2);
		block(0, 3, 1);
--		box(0, 3);
		tobj {
			nam = 'out';
			x = 8;
			y = 2;
			tile = 30;
			act = code [[ walk 'map7' ]];
			obstacle = true;
		},
		tobj {
			nam = '';
			x = 5;
			y = 5;
			w = 2;
			h = 2;
			act = function()
				local d = seen 'door'
				if not d.obstacle and not have 'rat' then
					walkin 'stopplz'
					return
				end
			end
		};
	}
}
