books = function(x, y, txt)
	return tobj {
		nam = 'books';
		obstacle = true;
		var { burning = false; here = false; };
		txt = txt;
		act = function(s)
			if s.burning then
				return [[Хорошо горят!]]
			end
			return stead.call(s, 'txt')
		end;
		x = x;
		y = y;
		tile = 45;
		used = function(s, w)
			if w == fakel then
				if s.burning then
					return "Уже горит!"
				end
				s.burning = rnd(16) + 32
				s.here = here()
				lifeon(s)
				local f = exist('fire', s)
				f:enable()
				return "Горите, проклятые книги!"
			end
			if w == topor then
				return "Топором книги не уничтожить..."
			end
		end;
		life = function(s)
			if player_moved() then
				if here() ~= s.here then
					lifeoff(s)
				end
				return
			end
			s.burning = s.burning - 1
			if s.burning == 0 then
				lifeoff(s)
				s:disable();
				put (new (string.format("garbage(%d, %d)", s.x, s.y)))
			end
		end;
		obj = {
			tobj {
				nam = 'fire';
				tile = 47;
				x = x;
				y = y;
				float = true;
			}:disable();
		}
	};
end

spider = tobj {
	nam = 'spider';
	float = true;
	var { 
		x = 6;
		y = 6;
		lives = 3;
		seen = false;
		obstacle = true;
		panic = 0;
		attack = false;
	};
	tile = 42;
	used = function(s, w)
		local x, y
		s.attack = false
		if w == topor then
			if s.panic > 0 then
				p [[Я ударил топором паука!]]
				s.lives = s.lives - 1
				if s.lives == 0 then
					p [[Тварь подохла!]]
					lifeoff(s)
					s:disable();
					put(blood)
					blood.x = s.x
					blood.y = s.y
				end
			else
				p [[Я замахнулся топором, но паук был быстрее...]]
				s.attack = true
			end
		elseif w == knife then
			if s.panic > 0 then
				p [[Я ударил ножом паука.]]
			else
				p [[Я взмахнул ножом, но паук был быстрее...]]
				s.attack = true
			end
		elseif w == fakel then
			p [[Я взмахнул перед собой факелом и паук отпрянул назад.]]
			s.panic = 2
			if s.y == me().y then
				if s.x < me().x then
					x, y = s.x - 1, s.y
				else
					x, y = s.x + 1, s.y
				end
			else -- x
				if s.y < me().y then
					x, y = s.x, s.y - 1
				else
					x, y = s.x, s.y + 1
				end
			end
			if not isObstacle(x, y) then
				s.x, s.y = x, y
			end
		end
	end;
	life = function(s)
		local attack = s.attack
		s.attack = false
		if s.panic > 0 then
			s.panic = s.panic - 1
			return
		end
		if math.abs(me().x - s.x) <= 1 and  math.abs(me().y - s.y) <= 1 then
			s.seen = true;
		end
		if s.seen then
			s.x, s.y = seek(s.x, s.y, me().x, me().y)
		end
		if s.x == me().x and s.y == me().y then
			if type(ACTION_TEXT) ~= 'string' or not attack then 
				p "Паук бросился на меня. Мохнатые холодные лапы крепко обхватили мою шею. Арабелла!"
			else 
				p (ACTION_TEXT)
			end
			gameover.tile = 42;
			walkin 'gameover'
		end
	end;
}

stick = tobj {
	tile = 39;
	var { x = 0, y = 0 };
	inv = 'Палка из деревянной ножки.';
	act = function(s) take(s); p "Я поднял с пола кусок деревяшки."; end;
	nouse = [[Потыкать палкой?]];
	use = function(s, w)
		if w == hobelen and taken(hobelen) then
			remove(w, me())
			p [[Я обмотал гобелен вокруг палки.]]
			replace(s, stick_hob, me())
		elseif nameof(w) == 'fireplace' then
			p [[Я попытался поджечь палку, не вышло.]]
		end
	end;
	used = function(s, w)
		return stead.call(s, 'use', w);
	end
}:disable();

stick_hob = tobj {
	tile = 40;
	inv = 'Палка из деревянной ножки, обмотанная гобеленом.';
	nouse = [[Потыкать палкой?]];
};

fakel = tobj {
	tile = 41;
	inv = 'Гобелен отлично горит!';
	act = function(s)
		take(s)
		p 'Я поднял факел.'
	end;
	var { x = 0, y = 0};
	nouse = [[Нет смысла это жечь.]];
};

hobelen = tobj {
	nam = 'hobelen';
	x = 1;
	y = 5;
	tile = 38;
	inv = [[На гобелене изображен мерзкий облик.]];
	act = [[Мерзкий гобелен украшает стену этой комнаты.]];
	used = function(s, w)
		if w == knife then
			if taken(s) then
				p [[Я изорвал гобелен в клочья!]]
				remove(s, me())
				return 
			end
			p [[Я срезал гобелен со стены.]]
			take(s)
			return
		end
	end
}

knife = tobj {
	tile = 44;
	inv = "Острый!";
	act = function(s) p 'Я забрал нож.'; take(s) end;
	var { x = 0, y = 0 };
	use = function(s, w)
		if w == rat then
			return "Плохая шутка."
		end
	end;
	nouse = 'Нож тут не поможет.';
}

map8 = troom {
	dsc = [[Выбрались! Сердце мое бешено билось, гулко отдавая в виски пульсом. Выбрались! Я осмотрелся. 
		На этот раз архитектура радовала разнообразием. Комнаты и двери. Что же, посмотрим...]];
	dsc2 = [[Выход с этого этажа находится за железной дверью, запираемой на ключ.]];
	active = {[[-- Как думаешь, много еще этажей?^
		-- Моя интуиция подсказывает, что мы прошли около половины пути, но...^
		-- Но?^
		-- Но геометрия внутри башни может искажаться...]], 
		[[-- Дровосек!^
		-- Что, Крыса?^
		-- Как тебя зовут?^
		-- Рон.. А как твое имя?^
		-- Не скажу...]],
		[[-- Скорее бы выбраться отсюда...^
		-- Я делаю все, что могу, Крыса...]];
	};
	nam = '6-й этаж';
	entered = function(s)
		me().x = 4
		me().y = 4
		key.x = 6
		key.y = 2
		lifeon(spider);
	end;
	left = function(s)
		lifeoff(spider);
	end;
	bg = {
		4,4,4,4,4,4,4,4,4,
		4,18,18,18,18,18,18,18,4,
		4,18,18,18,18,18,18,18,4,
		4,18,18,18,18,18,18,18,4,
		4,18,18,18,18,18,18,18,4,
		4,18,18,18,18,18,18,18,4,
		4,18,18,18,18,18,18,18,4,
		4,18,18,18,18,18,18,18,4,
		4,4,4,4,4,4,4,4,4,
	};
	ground = {
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,17,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,
	};
	wall = {
		1,1,1,1,1,1,1,1,1,
		2,0,0,0,0,31,0,0,3,
		35,0,0,32,0,31,0,0,3,
		1,33,33,2,0,3,33,0,1,
		2,0,0,0,0,0,0,0,3,
		1,33,33,35,0,34,33,0,1,
		2,0,0,31,0,31,0,0,3,
		2,0,0,0,0,31,0,0,3,
		1,33,33,33,33,1,33,33,1,
	};
	obj = {
		spider, 
		key, 
		tobj {
			nam = 'fireplace';
			obstacle = true;
			x = 0;
			y = 1;
			tile = 36;
			act = [[Кажется, растоплен недавно.]];
			used = function(s, w)
				if w == stick_hob then
					p [[Я поджег палку с гобеленом.]]
					replace(stick_hob, fakel, me())
				end
			end;
		},
		stick,
		tobj {
			nam = 'chair';
			x = 1;
			y = 1;
			tile = 37;
			used = function(s, w)
				if w == topor then
					p [[Я разломал стул.]]
					s:disable()
					if disabled 'stick' then
						stick.x = s.x
						stick.y = s.y
						enable(stick);
					end
				end
			end;
		},
		hobelen, 
		tobj {
			nam = 'out';
			act = code [[ walk 'map9' ]];
			x = 7;
			y = 7;
			tile = 17;
		},
		openable_door(7, 5);
		win(0, 2);
		win(0, 6);
		win(8, 2);
		wooden_door(3, 1, 3);
		wooden_door(3, 7, 3);
		tobj {
			nam = 'table';
			obstacle = true;
			x = 1;
			y = 2;
			tile = 43;
			used = function(s, w)
				if w == topor then
					p [[Я разломал стол.]]
					s:disable()
					if disabled 'stick' then
						stick.x = s.x
						stick.y = s.y
						enable(stick);
					end
				end
			end;

			act = function(s)
				if not taken 'knife' then
					take 'knife'
					return "На столе лежал нож.";
				end
				p "На столе больше ничего не было."
			end
		},
		block(7, 3, 33);
		win(8, 6);
		books(2, 6, [[Какие-то книги...]])
	};
}
